﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace CustomGroupByRecord
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public BindingList<Person> data { get; set; }
        public ObservableCollection<Person> coll { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            coll = new ObservableCollection<Person>();

            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 2, LastName = "Doe", Age = 34.5555 });
            coll.Add(new Person() { Id = 3, LastName = "Doe", Age = 56 });
            coll.Add(new Person() { Id = 4, LastName = "Smith", Age = 23 });

            data = new BindingList<Person>(coll);
            this.DataContext = data;
        }



        private void button1_Click(object sender, RoutedEventArgs e)
        {
            data.Add(new Person() { Id = 4, LastName = "Smith", Age = 23 });
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;


        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double age;

        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }

        }

    }

    public class MyConverter1 : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                if (value.ToString() == "Smith")
                {
                    return "My Converted Value!";
                }
                else
                    return value.ToString();
            }
            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class MyConverter2 : IMultiValueConverter
    {

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values[0] != null)
            {
                if ((values[0] as GroupByRecord).GroupByField != null)
                {
                    return (values[0] as GroupByRecord).Description.Remove(0, (values[0] as GroupByRecord).Value.ToString().Length).ToString();
                }
            }
            return Binding.DoNothing;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
